#!/usr/bin/env node
const path = require('path')
const chalk = require('chalk')
const shell = require('shelljs')
const bootstrap = require('commitizen/dist/cli/git-cz').bootstrap

const findMergeMessage = require('../utils/find-merge-message.js')

const mergeMessage = findMergeMessage(process.env.PWD)

if (!!mergeMessage) {
  const branchRegExp = /Merge (?:branch|commit) '(.*)'/
  const mergeInfos = branchRegExp.exec(mergeMessage)

  let commitCommand 
  if (Array.isArray(mergeInfos) && mergeInfos[1]) {
    commitCommand = `git commit -m "merge(${mergeInfos[1]}): ${mergeMessage}"`
  } else {
    commitCommand = `git commit -m "${mergeMessage}"`
  }
  shell.echo(chalk.yellow('当前为merge，保留merge信息提交'))
  
  if (shell.exec(commitCommand).code !== 0) {
    shell.echo('提交失败请检查')
    shell.exit(1)
  } else {
    shell.exit(0)
  }
} else {
  bootstrap({
    cliPath: path.join(process.env.PWD || process.env.INIT_CWD, './node_modules/commitizen'),
    config: {
      "path": "cz-conventional-changelog"
    }
  })
}

